// File:		BitMatrix.h
// Created:		13-Mar-2001 G.Macharashvili JINR Dubna
// E-mail:		gogi@nu.jinr.ru
// Subject:		Bit Set 2 Dimensional Matrix Class
// Source:		14-Aug-1997 G.Macharashvili

#if !defined(BITMATRIX_H)
#define	BITMATRIX_H

#include "BitVector.h"

class BitMatrix : protected BitVector {

public:

	BitMatrix(BitNumType row=32,BitNumType col=32) ;
virtual	~BitMatrix() ;

	void		Print() ;

	void		Set(const char* s,int row,BitNumType b1,BitNumType b2) ;
	void		Set(BitNumType x,BitNumType y) ;
	void		Clear(BitNumType x,BitNumType y) ;
	void		Invert(BitNumType x,BitNumType y) ;
	int		Test(BitNumType x,BitNumType y) ;
	void		Put(BitNumType x,BitNumType y,int val) ;

	BitNumType	SetBits() const ;
	BitNumType	ClearBits() const ;

	BitNumType	MaxBit() { return  BitVector::MaxBit() ; }
	
inline	int		NumOfX() const { return NX ; }
inline	int		NumOfY() const { return NY ; }

//	BitNumType	Index(BitNumType bit_i,BitNumType bit_j) ;
BitNumType
	BitMatrix::Index(BitNumType ix,BitNumType iy) { 
	if (ix<0 || ix>NX || iy<0 || iy>NY) return (-1) ;
	else return ix+iy*NX ;
	}

private:

// INDEXING: First  x==[0..NX-1]
//           Second y==[0..NY-1]

	BitNumType	NX , NY ;

	} ;

#endif

// EOF
