// File:		BitVector.h
// Created:		13-Mar-2001 G.Macharashvili JINR Dubna
// E-mail:		gogi@nu.jinr.ru
// Subject:		Bit Set Class (One Dimensional Base Class)
// Source:		05-Aug-1997 G.Macharashvili

#if !defined(BITSTRING_H)
#define	BITSTRING_H

#include <iostream.h>
#include <string.h>
#include <stdlib.h>

typedef int BitNumType ;
typedef bool BitBool ;

class BitVector {

public:

	BitVector(BitNumType bits=32) ;
virtual	~BitVector() ;

	void		Print(BitNumType nb=0) ;
	void		Print(BitNumType nb1,BitNumType nb2) ;
	void		Set(BitNumType bit1,BitNumType bit2) ;
	void		Set(BitNumType bit) ;
	void		Set() ;
	void		Clear(BitNumType bit1,BitNumType bit2) ;
	void		Clear(BitNumType bit) ;
	void		Clear() ;
	void		Invert(BitNumType bit1,BitNumType bit2) ;
	void		Invert(BitNumType bit) ;
	void		Invert() ;

	int		Test(BitNumType bit1,BitNumType bit2) const ;
	int		Test(BitNumType bit) const ;
	int		Get(BitNumType bit) const ;
	void		Put(BitNumType bit,int val=1) ;
	BitNumType	FindFirstSet(BitNumType start_bit,BitNumType end_bit) const ;
	BitNumType	FindFirstClear(BitNumType start_bit,BitNumType end_bit) const ;
unsigned long		Extract(BitNumType bit1,BitNumType bit2) ;
	void		Insert(long src,BitNumType bit1,BitNumType bit2) ;
	void		Insert(const char* s,BitNumType bit1,BitNumType bit2) ;
	BitNumType	SetBits() const ;
	BitNumType	ClearBits() const ;

	BitNumType	MaxBit() const ;

protected:

	char*		base ;
	BitNumType	maxbit ;
static	const	int	ERR=0 ;

	} ;

#endif

// EOF
