// File:	E391aCCo3SensitiveDetector.hh
// Date:	25-Nov-2001 G.Macharashvili Dubna

#ifndef E391aCCo3SensitiveDetector_h
#define E391aCCo3SensitiveDetector_h 1

#include "E391aPType.hh"
#include "E391aHit.hh"
//#include "E391aVDigitizerModule.hh"
#include "E391aVSensitiveDetector.hh"

//#include "StepClassifier.hh"

#include "G4VSensitiveDetector.hh"
#include "G4StepStatus.hh"
#include "G4LogicalVolume.hh"
#include "G4TouchableHistory.hh"
#include "G4AffineTransform.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"
//#include "G4DigiManager.hh"
#include "G4RunManager.hh"

#include "TH1.h"
#include "TH2.h"


class E391aCC3SensitiveDetector : public E391aVSensitiveDetector {

static	const	G4int		CCBaseID=3 ;
static	const	G4double	ESensitivityThreshold=1*MeV ;
static	const	G4int		xHitMax=2 ;

public:

	E391aCC3SensitiveDetector(G4String) ;
	~E391aCC3SensitiveDetector() ;
  
	void		Initialize(G4HCofThisEvent*) ;
	G4bool		ProcessHits(G4Step*,G4TouchableHistory*) ;
	void		EndOfEvent(G4HCofThisEvent*) ;

	void		CreateHits() ;
	void		SetInitialParticleData(G4Step *S) ;
	void		AddInitialParticleData(G4Step *S) ;

	void		clear() {}
	void		DrawAll() {}
	void		PrintAll() {}

private:

	E391aHitsCollection		*HC ;
	G4int				MaxTrack ;
	G4int				InitHit ;

	G4int				Module ;
	G4int				CNo ;
	G4int				ScNo ;

	TH1F				*CC3Spect , *CC3Dep , *CC3NTrk ;
	TH1F				*CC3Effo , *CC3Eff , *CC3EI ;
	TH2F				*CC3HitXY1 , *CC3HitXY1u ;
	TH2F				*CC3HitXY2 , *CC3HitXY2u ;
	TH2F				*CC3EkEvis , *CC3EkEvisS , *CC3EkEvisW ;
	TH2F				*CC3EsEw ;
	TH2F				*CC3LocXY ;

	} ;

#endif

// EOF
