// File:	E391aCCo4-SD.hh
// Date:	25-Sep-2001 G.Macharashvili Juelich
// Updated:	

#ifndef E391aCCo4SD_h
#define E391aCCo4SD_h 1

#include "E391aVDigitizerModule.hh"
#include "E391aPType.hh"
#include "E391aHit.hh"

#include "G4VSensitiveDetector.hh"
#include "G4LogicalVolume.hh"
#include "G4TouchableHistory.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"
#include "G4DigiManager.hh"

#include "TH1.h"
#include "TH2.h"

class E391aDetectorConstruction ;

class E391aCCo4SensitiveDetector : public G4VSensitiveDetector {

static	const	G4int		CCBaseID=4 ;
static	const	G4double	ESensitivityThreshold=10*MeV ;
static	const	G4int		xHitMax=1 ;

public:

	E391aCCo4SensitiveDetector(G4String) ;
	~E391aCCo4SensitiveDetector() ;
  
	void		Initialize(G4HCofThisEvent*) ;
	G4bool		ProcessHits(G4Step*,G4TouchableHistory*) ;
	void		EndOfEvent(G4HCofThisEvent*) ;
	void		clear() {}
	void		DrawAll() {}
	void		PrintAll() {}
	void		HitFill(G4int id,G4Step *S) ;

private:

	E391aHitsCollection		*HC ;
	G4int				*HitID ;
	G4int				ParID ;
	G4int				TrackID ;
	G4int				MaxTrack ;
	G4VDigitizerModule		*DigM ;

	TH1F				*CCo4Spect , *CCo4Dep , *CCo4NTrk ;
	TH1F				*CCo4Effo , *CCo4Eff ;
	TH2F				*CCo4HitXY , *CCo4HitXYu ;

	} ;

#endif

// EOF
