// File:	E391aCCo5-SD.hh
// Date:	16-Oct-2001 G.Macharashvili Juelich
// Updated:	

#ifndef E391aCCo5SD_h
#define E391aCCo5SD_h 1

#include "E391aVDigitizerModule.hh"
#include "E391aPType.hh"
#include "E391aHit.hh"

#include "G4VSensitiveDetector.hh"
#include "G4LogicalVolume.hh"
#include "G4TouchableHistory.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"
#include "G4DigiManager.hh"

#include "TH1.h"
#include "TH2.h"

class E391aDetectorConstruction ;

class E391aCCo5SensitiveDetector : public G4VSensitiveDetector {

static	const	G4int		CCBaseID=5 ;
static	const	G4double	ESensitivityThreshold=4*MeV ;
static	const	G4int		xHitMax=1 ;

public:

	E391aCCo5SensitiveDetector(G4String) ;
	~E391aCCo5SensitiveDetector() ;
  
	void		Initialize(G4HCofThisEvent*) ;
	G4bool		ProcessHits(G4Step*,G4TouchableHistory*) ;
	void		EndOfEvent(G4HCofThisEvent*) ;
	void		clear() {}
	void		DrawAll() {}
	void		PrintAll() {}
	void		HitFill(G4int id,G4Step *S) ;

private:

	E391aHitsCollection		*HC ;
	G4int				*HitID ;
	G4int				ParID ;
	G4int				TrackID ;
	G4int				MaxTrack ;
	G4VDigitizerModule		*DigM ;

	TH1F				*CCo5Spect , *CCo5Dep , *CCo5NTrk ;
	TH1F				*CCo5Effo , *CCo5Eff ;
	TH2F				*CCo5HitXY , *CCo5HitXYu ;

	} ;

#endif

// EOF
