// File:	E391aCH-Digi.hh
// Date:	20-Sep-2001 G.Macharashvili Juelich
// Updated:

#ifndef E391aCHDigitizer_h
#define E391aCHDigitizer_h 1

#include "E391aVDigitizerModule.hh"
#include "E391aHit.hh"
#include "E391aCH-SD.hh"
#include "E391aDigi.hh"
#include "TimeDigitizer.hh"

#include "G4DigiManager.hh"

#include "CLHEP/Random/RandGaussQ.h"
#include "CLHEP/Random/RandPoissonQ.h"

class E391aCHDigitizer : public E391aVDigitizerModule {

static	const	G4bool		ESigmaON=true ;
static	const	G4bool		PedSigmaON=false ;
static	const	G4double	MeV2Npe=10 ;
static	const	G4double	Npe2QDC=1 ;
static	const	G4double	QDCPedSigma=1 ;
static	const	G4int		xMaxDigi=16 ;

public:

	E391aCHDigitizer(G4String) ;
	~E391aCHDigitizer() ;
  
	void		Digitize() ;
	void		Digitize(E391aHitsCollection *) ;
	void		MakeDigi(E391aHit *H) ;
	void		DigiFill(G4int,G4double,G4double) ;
	G4double	ERand(G4double) ;
	G4double	PedestalRand() ;
	G4double	QDC(G4double e) ;

private:

	E391aHitsCollection		*HC ;
	E391aDigiCollection		*DC ;
	G4int				*DigiID ;
	TimeDigitizer			TDC ;

	} ;

#endif

// EOF
