// File:	E391aCH-SD.hh
// Date:	06-Sep-2001 G.Macharashvili Dubna
// Updated:	

#ifndef E391aChargedVetoSD_h
#define E391aChargedVetoSD_h 1

#include "E391aVDigitizerModule.hh"
#include "E391aPType.hh"
#include "E391aHit.hh"

#include "G4VSensitiveDetector.hh"
#include "G4LogicalVolume.hh"
#include "G4TouchableHistory.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"
//#include "G4DigiManager.hh"

#include "TH1.h"
#include "TH2.h"

class E391aDetectorConstruction ;

class E391aChargedVetoDetector : public G4VSensitiveDetector {

static	const	G4int		CHDetectorID=9 ;
static	const	G4double	xEkMin=0 ;
static	const	G4int		xHitMax=16 ;

public:

	E391aChargedVetoDetector(G4String,E391aDetectorConstruction*) ;
	~E391aChargedVetoDetector() ;
  
	E391aDetectorConstruction* Det() { return xDet ; }
	void		Initialize(G4HCofThisEvent*) ;
	G4bool		ProcessHits(G4Step*,G4TouchableHistory*) ;
	void		EndOfEvent(G4HCofThisEvent*) ;
	void		clear() {}
	void		DrawAll() {}
	void		PrintAll() {}
	void		HitFill(G4int id,G4Step *S) ;

private:

	E391aDetectorConstruction	*xDet ;
	E391aHitsCollection		*HC ;
	G4int				*HitID ;
	G4int				ParID ;
	G4int				TrackID ;
	G4int				module ;

	TH1F				*CHSpectE , *CHSpectG ;
	TH1F				*CHEDep ;
	TH2F				*CHHitXY ;

	} ;

#endif

// EOF
