// File:	E391aCalorimeterConfig.hh
// Date:	14-May-2001 G.Macharashvili Dubna
// Updated:	19-Oct-2001 G.Macharashvili Juelich

#ifndef E391aCalorimeterConfig_h
#define E391aCalorimeterConfig_h 1

#include "BitMatrix.h"

#include "G4UnitsTable.hh"

//#define KAMI 1

class E391aCalorimeterConfig : public BitMatrix {

static	const	int		xBaseIdent=0 ;
static	const	double		Do=7.0*cm ;

public:

	E391aCalorimeterConfig() ;
	~E391aCalorimeterConfig() ;
  
inline	int		Base() { return xBaseIdent ; }
inline	int		Ident(int ix,int iy) { return ix+iy*100 ; }
inline	int		XNo(int id) { return (id-xBaseIdent)%100 ; }
inline	int		XNo(double x) { return int((x+13.5*Do)/Do) ; }
inline	int		YNo(int id) { return (id-xBaseIdent)/100 ; }
inline	int		YNo(double x) { return int((x+13.5*Do)/Do) ; }
inline	double		XCenter(int i) { return (i-13)*Do ; }
inline	double		YCenter(int i) { return (i-13)*Do ; }
inline	double		XCenter(double x) { return (XNo(x)-13)*Do ; }
inline	double		YCenter(double y) { return (YNo(y)-13)*Do ; }
inline	double		DD() { return Do ; }
inline	int		AtEdge(int ix,int iy) const { return Edge->Test(ix,iy) ; }

private:

	BitMatrix	*Edge ;

	} ;

#endif

// EOF
