// File:	E391aCalorimeterDigitizer.hh
// Date:	14-May-2001 G.Macharashvili Dubna
// Updated:	12-Jun-2001 G.Macharashvili Dubna
// Updated:	26-Jun-2001 G.Macharashvili Dubna

#ifndef E391aCalorimeterDigitizer_h
#define E391aCalorimeterDigitizer_h 1

#include "E391aVDigitizerModule.hh"
#include "E391aCalorimeterSD.hh"
#include "E391aHit.hh"
#include "E391aDigi.hh"
#include "TimeDigitizer.hh"

#include "G4DigiManager.hh"

#include "CLHEP/Random/RandGaussQ.h"

class E391aCalorimeterDigitizer : public E391aVDigitizerModule {

static	const	G4bool		ESigmaON=true ;
static	const	G4bool		PedSigmaON=false ;
static	const	G4double	QDCScale=4*MeV ;
static	const	G4double	QDCPedSigma=1 ;
static	const	G4double	Ea=0.0254 ; // 0.0186 ;
static	const	G4double	Eb=0.0125 ; // 0.0084 ;

public:

	E391aCalorimeterDigitizer(G4String,E391aCalorimeterConfig *) ;
	~E391aCalorimeterDigitizer() ;
  
	void		Digitize() ;
	void		Digitize(E391aHitsCollection*) ;
	void		PartialE(G4double xReal,G4double xPrime,G4double xCenter,G4double e[]) ;
	void		EMShowerModel(E391aHit*) ;
	void		DigiFill(G4int,G4int,G4double,G4double) ;
	G4double	ERand(G4double) ;
	G4double	PedestalRand() ;
	G4double	QDC(G4double e) ;

private:

	E391aCalorimeterConfig		*Config ;
	E391aHitsCollection		*HC ;
	E391aDigiCollection		*DC ;
	G4int				*DigiID ;
	TimeDigitizer			TDC ;

	} ;

#endif

// EOF
