// File:	E391aCalorimeterSD.hh
// Date:	03-May-2001 G.Macharashvili Dubna
// Updated:	13-Jun-2001 G.Macharashvili Dubna
// Updated:	02-Nov-2001 G.Macharashvili Dubna

#ifndef E391aCalorimeterSD_h
#define E391aCalorimeterSD_h 1

#include "E391aVDigitizerModule.hh"
#include "E391aPType.hh"
#include "E391aHit.hh"
#include "E391aCalorimeterConfig.hh"

#include "G4VSensitiveDetector.hh"
#include "G4LogicalVolume.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"
#include "G4DigiManager.hh"

class E391aDetectorConstruction ;

class E391aCalorimeterSD : public G4VSensitiveDetector {

static	const	G4double	xEkMin=0 ;
static	const	G4int		xHitMax=100 ;

public:

	E391aCalorimeterSD(G4String,E391aDetectorConstruction*,E391aCalorimeterConfig *cfg) ;
	~E391aCalorimeterSD() ;
  
	E391aDetectorConstruction* Det() { return xDet ; }
	void		Initialize(G4HCofThisEvent*) ;
	G4bool		ProcessHits(G4Step*,G4TouchableHistory*) ;
	void		EndOfEvent(G4HCofThisEvent*) ;
	void		clear() {}
	void		DrawAll() {}
	void		PrintAll() {}
	void		HitFill(G4int,G4int,G4ThreeVector&,G4ThreeVector&,G4double,G4double) ;
	void		HitFill(G4int id,G4Step *S) ;

private:

	E391aDetectorConstruction	*xDet ;
	E391aCalorimeterConfig		*Config ;
	E391aHitsCollection		*HC ;
	G4int				*HitID ;
	G4int				ParID ;
	G4int				TrackID ;

	} ;

#endif

// EOF
