// File:	E391aEventAction.hh
// Date:	16-Apr-2001 G.Macharashvili Juelich

#ifndef E391aEventAction_h
#define E391aEventAction_h 1

#include "E391aDigitizerManager.hh"
#include "E391aDetectorConstruction.hh"
#include "E391aPrimaryGeneratorAction.hh"
#include "E391aCalorimeterFilter.hh"
#include "E391aEventWriter.hh"

#include "G4Event.hh"
#include "G4UserEventAction.hh"
#include "G4EventManager.hh"
#include "G4HCofThisEvent.hh"

#include "TFile.h"
#include "RunMessage.h"
extern	RunMessage	*RootMsg ;

class E391aEventAction : public G4UserEventAction {

public:

		E391aEventAction(E391aDetectorConstruction*,E391aPrimaryGeneratorAction*,TFile*) ;
virtual		~E391aEventAction() ;

virtual	void	BeginOfEventAction(const G4Event*) ;
virtual	void	EndOfEventAction(const G4Event*) ;

	void	SetHitVerbose(G4int) ;

private:

	E391aDetectorConstruction	*Det ;
	E391aPrimaryGeneratorAction	*Gen ;
	TFile				*HFile ;
	E391aEventWriter		*OStream ;
	E391aCalorimeterFilter		*Filter ;

	} ;

#endif

// EOF
