// File:	E391aEventWriter.hh
// Date:	09-Oct-2001 G.Macharashvili Juelich

#ifndef E391aEventWriter_h
#define E391aEventWriter_h 1

#include <G4Event.hh>
#include <G4DCofThisEvent.hh>

#include <E391aDigi.hh>
#include <iostream.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <stdio.h>
#include <string.h>

class E391aEventWriter {

static	E391aEventWriter	*Ptr ;

public:

		E391aEventWriter(const char *FileName=0) ;
		~E391aEventWriter() { Close() ; }

static	E391aEventWriter	*GetPointer() { return Ptr ; }

protected:

	void	Close() { if (f!=0) fclose(f) ; f=0 ; }
	int	Signal(int Q,int T) { return ((T&0x8FFF)<<16)+(Q&0x8FFF) ; }

public:

	bool	Open(const char *fnm) ;
	void	Print() ;
	bool	Write() ;
//	void	Start() { fseek(f,0l,SEEK_SET) ; }
	void	Init(int run=0,int trig=0) ;
	bool	AddData(E391aDigiCollection *DC) ;
	bool	AddData(E391aDigi *d) ;
	bool	AddData(int id,double Q,double T) ;
	bool	AddData(int id,int Q,int T) ;
	bool	GetDigits(const G4Event *E) ;

protected:

struct	stat	FAttr ;
	FILE	*f ;
	int	*buf , *p ;

	} ;

#endif
	
// EOF
