// File:	Generator2.hh
// Date:	21-May-2001 G.Macharashvili Dubna

#ifndef E391aPrimaryGeneratorAction_h
#define E391aPrimaryGeneratorAction_h 1

#include "E391aBeam.hh"
#include "E391aDecayPos.hh"
#include "E391aPrimaryTrigger.hh"
#include "Map.hh"

#include "G4VUserPrimaryGeneratorAction.hh"
#include "G4Event.hh"
#include "G4ParticleGun.hh"
#include "G4DecayTable.hh"
#include "G4PhaseSpaceDecayChannel.hh"
#include "G4ParticleTable.hh"
#include "G4ParticleDefinition.hh"
#include "G4PrimaryParticle.hh"
#include "G4DynamicParticle.hh"
#include "G4DecayProducts.hh"
#include "G4LorentzVector.hh"
#include "G4PrimaryVertex.hh"
#include "G4ThreeVector.hh"

#include "TH1.h"
#include "TH2.h"

class E391aPrimaryGeneratorAction : public G4VUserPrimaryGeneratorAction {

private:

const	static	G4double	Zmin=2.75*m ;
const	static	G4double	Zmax=6.50*m ;
//const	static	G4double	Zmin=5.00*m ;
//const	static	G4double	Zmax=7.00*m ;

	G4ParticleGun		*PGun ;
	E391aBeam		*Beam ;
	E391aDecayPos		*PosGen ;
	E391aPrimaryTrigger	*PreTrigger ;
 
	G4ParticleDefinition	*KLong ;
	G4ParticleDefinition	*Pion0 ;
	G4ParticleDefinition	*G ;
	G4DecayTable		*DT ;
	G4VDecayChannel		*KC , *PC ;
	Map<G4DynamicParticle>	NP ;

	G4double		KLongKineticEnergy ;
	G4double		KLongMomentum ;
	G4ThreeVector		KLongDirection ;
	G4ThreeVector		KLongDecayPoint ;
	G4int			KLongDecayMode ;
	G4LorentzVector		K4 ;
	G4DynamicParticle	*KD ;
	G4LorentzVector		X ;
	G4double		CosThCM ;

	TH2F			*HBeamProfXY,*HBeamProfXZ ;
	TH1F			*HKLongDecayZ ;
	TH1F			*HPionPT,*HPionPhi,*HPionCosTh ;
	TH1F			*HPionPLab ;
	TH1F			*HGammaPT,*HGammaE,*HGammaThLab ;

public:

		E391aPrimaryGeneratorAction() ;
		~E391aPrimaryGeneratorAction() ;

	void			GeneratePrimaries(G4Event* Evt) ;
	void			RegisterParticle(G4Event* Evt,G4ThreeVector &Vtx,G4DynamicParticle *P) ;

inline	G4double		PionPT() { return X.perp() ; }
inline	G4double		GenKLongKineticEnergy() { return KLongKineticEnergy ; }
inline	G4double		GenKLongMomentum() { return KLongMomentum ; }
inline	G4ThreeVector		GenKLongDirection() { return KLongDirection ; }
inline	G4ThreeVector		GenKLongDecayPoint() { return KLongDecayPoint ; }
inline	G4int			GenKLongDecayMode() { return KLongDecayMode ; }

	void			PionHistFill() ;
	void			BeamHistFill() ;

	} ;

#endif

// EOF
