// File:	scanner.cc
// Date:	16-Oct-2001 G.M. Juelich

#include "E391aEventReader.hh"

#include <ctype.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char **argv) {

	char*		FileName=(char *)0 ;
	unsigned	MaxEvtReq=0xFFFFFFFF ;
	bool		Help=false ;
	bool		Verify=false ;
	bool		DumpV=false ;
	bool		Silent=true ;

	for (int k=1 ; k<argc ; k++) {
		char *s=argv[k] ;
		if (*s=='-') {
			while (*s) {
				switch (*s++) {
					default:
					case 'h': Help=true ;
						cout.form("\nusage: %s [t#] [-ovh] [DataFile] [#n]\n",argv[0]) ;
						cout.form("\n  if input file is not specified \'stdin\' assumed") ;
						//cout.form("\n  -t#m        -- Select only one trigger for output") ;
						cout.form("\n  -v          -- Verification mode") ;
						cout.form("\n  -q          -- Silent mode (default)") ;
						cout.form("\n  #n          -- Number of events to read. 0=All") ;
						cout.form("\n") ;
						exit(0) ;
						  break ;
					case '-': break ;
//					case 't': ReqTrig=atoi(s) ;
//						  while(*s!='\0') s++ ;
//						  break ;
					case 'v': Verify=true ;
						  Silent=false ;
						  break ;
					case 'd': DumpV=true ;
						  Silent=false ;
						  break ;
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
					case '0':
						  MaxEvtReq=atoi(s-1) ;
						  if (MaxEvtReq==0) MaxEvtReq=0xFFFFFFFF ;
						  break ;
					}
				}
			}
		else if (isdigit(*s)) MaxEvtReq=atoi(s) ;
		else FileName=s ;
		}

	E391aEventReader *E=new E391aEventReader("DataFile.bin") ;
	unsigned	NumOfEvents=0 ;
	cout.form("\nScan ...\n") ;
	while (E->Read() && ++NumOfEvents<MaxEvtReq) {
		if (DumpV) E->Dump() ;
		if (Verify) E->Print() ;
		}
	cout.form("%u Events read\n",NumOfEvents) ;
	cout.form("Verification: OK ...\n\n") ;
	delete E ;
	return 0 ;
	}

// EOF
