// File:		BitMatrix.cc
// Created:		13-Mar-2001 G.Macharashvili JINR Dubna
// E-mail:		gogi@nu.jinr.ru
// Subject:		Bit Set 2 Dimensional Matrix Class
// Source:		14-Aug-1997 G.Macharashvili

#include "BitMatrix.h"

BitMatrix::BitMatrix(BitNumType nx,BitNumType ny) : BitVector(nx*ny) {
	NX=nx ;
	NY=ny ;
	}

BitMatrix::~BitMatrix() {}

void	BitMatrix::Set(const char* s,int row,BitNumType b1,BitNumType b2) {
	do {
		switch (*s++) {
			default:
			case '0':  BitVector::Clear(Index(row,b1++)) ;
				   break ;
			case '1':  BitVector::Set(Index(row,b1++)) ;
				   break ;
			case ' ':
			case '\t':
				   break ;
			case 0:    return ;
			}
		} while (b1<=b2) ;
	}

void	BitMatrix::Set(BitNumType bit_i,BitNumType bit_j) { BitVector::Set(Index(bit_i,bit_j)) ; }

void	BitMatrix::Clear(BitNumType bit_i,BitNumType bit_j) { BitVector::Clear(Index(bit_i,bit_j)) ; }

void	BitMatrix::Invert(BitNumType bit_i,BitNumType bit_j) { BitVector::Invert(Index(bit_i,bit_j)) ; }

int	BitMatrix::Test(BitNumType bit_i,BitNumType bit_j) { return BitVector::Test(Index(bit_i,bit_j)) ; }

void	BitMatrix::Put(BitNumType bit_i,BitNumType bit_j,int val) {
	val==0 ? BitVector::Clear(Index(bit_i,bit_j)) :
		 BitVector::Set(Index(bit_i,bit_j)) ;
	}

BitNumType	BitMatrix::SetBits() const { return BitVector::SetBits() ; }

BitNumType	BitMatrix::ClearBits() const { return BitVector::ClearBits() ; }

void	BitMatrix::Print() {
	cout.form("\nBitMatrix: %p",this) ;
	cout.form("\nBitMatrix::Print()  (%d)  Bits: %d x %d  (%d B)",BitVector::MaxBit()+1,NX,NY,BitVector::MaxBit()/8+1) ;
	cout.form("\nSetBits: %d  ClearBits: %d",SetBits(),ClearBits()) ;
	if(NX>32||NY>64) return ;
	for (int i=0 ; i<NX ; i++) {
		cout.form("\n %2d  ",i) ;
		for (int j=0 ; j<NY ; j++) {
//			cout.form(" %1d",Test(i,j)) ;
			cout.form(" %c",Test(i,j)?'X':'.') ;
			}
		}
	cout.form("\n") ;
	}

// EOF
