// File:		DynamicGamma.cc
// Date:		25-May-2001 G.Macharashvili Dubna

#include "DynamicGamma.hh"

Gamma::Gamma(double x,double y,double e,double dx,double dy,double t) {
	Mom(0) ;
	oX=x ; oY=y ; oZ=Zec ; oE=e ; oT=t ;
	oDx=dx ; oDy=dy ;
	}

Gamma::Gamma(const Gamma &g) {
	oX=g.oX ; oY=g.oY ; oZ=g.oZ ; oE=g.oE ; oT=g.oT ;
	oDx=g.oDx ; oDy=g.oDy ;
	Mom=g.Mom ;
	}

Gamma::~Gamma() {}

const	Gamma&	Gamma::operator=(const Gamma &g) {
	oX=g.oX ; oY=g.oY ; oZ=g.oZ ; oE=g.oE ; oT=g.oT ;
	oDx=g.oDx ; oDy=g.oDy ;
	Mom=g.Mom ;
	return *this ;
	}

int	Gamma::operator>(const Gamma &g) const {
	return oE>g.oE ;
	}

int	Gamma::operator<(const Gamma &g) const {
	return oE<g.oE ;
	}

void	Gamma::InitMomentum(G4double Zdecay) {
	double d=sqrt(oX*oX+oY*oY+(Zec-Zdecay)*(Zec-Zdecay)) ;
	Mom=G4ThreeVector(oX*oE/d,oY*oE/d,(Zec-Zdecay)*oE/d) ;
	}

void	Gamma::Print() {
	cout.form("Gamma: ") ;
	cout.form("%7.1f ",oX/mm) ;
	cout.form("%7.1f ",oY/mm) ;
	cout.form("%7.1f ",oE/MeV) ;
	cout.form("%7.1f ",oT) ;
	cout.form("\n") ;
	}

// EOF
