// File:	E391aDecayPos.cc
// Date:	15-Jun-2001 G.Macharashvili Dubna

#include "E391aDecayPos.hh"

E391aDecayPos::E391aDecayPos(G4double zmin,G4double zmax) {
	sum=0 ;
	NEvt=0 ;
	zo=zmin ; zv=zmax-zmin ;
	HDPos=new TH1F("HDPos","KLong Decay Pos (Weighted)",200,zmin/cm,zmax/cm) ;
		HDPos->SetXTitle("Decay Z coordinate,  cm") ;
		HDPos->SetYTitle("Decay probability / 2 cm") ;
	}

E391aDecayPos::~E391aDecayPos() { Print() ; }

G4double	E391aDecayPos::KLongZ(G4double beta) {
	G4double z=G4UniformRand()*zv+zo ;
	if (beta<0.001) beta=0.001 ;
	G4double w=1/beta/CTau*exp(-z/beta/CTau) ;
	HDPos->Fill(z/cm,w*HDPos->GetBinWidth(1)) ;
	sum+=w ;
	NEvt++ ;
	return z ;
	}

void	E391aDecayPos::Print() {
	G4cout.form(" Decay Probability: %.2f \%\n",Prob()*100) ;
	}

G4double	E391aDecayPos::Prob() { return sum/NEvt*zv ; }

// EOF
