// File:	E391aEventAction.cc
// Date:	16-Apr-2001 G.Macharashvili Juelich

#include "E391aEventAction.hh"

E391aEventAction::E391aEventAction
	(E391aDetectorConstruction* det,E391aPrimaryGeneratorAction* gen,TFile *HF)
	:
	Det(det),Gen(gen),HFile(HF),Filter(0),OStream(0) {
//	G4EventManager::GetEventManager()->SetVerboseLevel(1) ;
	/////////////////////////////////////////////////////
	}

E391aEventAction::~E391aEventAction() {}

void
E391aEventAction::BeginOfEventAction(const G4Event* Evt) {
//	G4cout<<"\nE391aEventAction::BeginOfEventAction() \n" ;
	if (Filter==0) Filter=Det->CalorimeterFilter() ;
// ... Initialize output data event
	if (OStream==0) OStream=E391aEventWriter::GetPointer() ;
	OStream->Init(44,4) ;
// ...
	if (RootMsg) {
		if (Evt->GetEventID()>10000) {
			if (!(Evt->GetEventID()%10000)) {
				HFile->Write(0,TObject::kOverwrite) ;
				RootMsg->SpeedInfo(Evt->GetEventID()) ;
				}
			}
		}
	}

void	E391aEventAction::EndOfEventAction(const G4Event* Evt) {
//	G4cout.form("E391aEventAction::EndOfEventAction() ... Evt: %d\n",Evt->GetEventID()) ;

// Make digitization for all detector digitizers have been registered
	E391aDigitizerManager::DigitizeHitsForThisEvent(Evt) ;

// ... Write output data stream
	OStream->GetDigits(Evt) ;
//	OStream->Print() ;
	OStream->Write() ;
// ... End

// ... Run calorimeter filter for event
	Filter->Init(Evt) ;
	Filter->ProcessEvent(Gen) ;
	Filter->End() ;

	}

void	E391aEventAction::SetHitVerbose(G4int val) {}

// EOF
