// File:	E391aEventReader.cc
// Date:	09-Oct-2001 G.Macharashvili Juelich

#include "E391aEventReader.hh"

	E391aEventReader::E391aEventReader(const char *FileName=0) {
			buf=new int [2048*4] ;
			f=0 ;
			buf[2]=0 ;
			Open(FileName) ;
			}
//	E391aEventReader::E391aEventReader(FILE *fd) ; // check write permission

bool	E391aEventReader::Open(const char *fnm) {
	if (fnm==(const char *)0) {
		f=stdin ;
		return true ;
		}
	else if ((f=fopen(fnm,"rb"))<=0) {
		cout.form("E391aEventReader:: %s - Open Err ...\n",fnm) ;
		exit(0) ;
		}
	else return true ;
	}

bool	E391aEventReader::Read() { 
	if (fread(buf,sizeof(int),1,f)==1) {
		int len=fread(buf+1,sizeof(int),buf[0]-1,f) ;
		if (len==buf[0]-1) return true ;
		}
	else return false ;
	}

int	E391aEventReader::SignalID(int k) const {
		if (k<buf[7]) return buf[8+k*2] ;
		else return (-1) ;
		}
int	E391aEventReader::DetectorID(int k) const {
		if (k<buf[7]) return buf[8+k*2]/10000 ;
		else return (-1) ;
		}
int	E391aEventReader::ModuleID(int k) const {
		if (k<buf[7]) return buf[8+k*2]%10000 ;
		else return (-1) ;
		}
int	E391aEventReader::QDC(int k) const {
		if (k<buf[7]) return buf[8+k*2+1]&0x8FFF ;
		else return (-1) ;
		}
int	E391aEventReader::TDC(int k) const {
		if (k<buf[7]) return (buf[8+k*2+1]>>16)&0x8FFF ;
		else return (-1) ;
		}

void	E391aEventReader::Print() {
	cout.form("E391aEventReader::EventSeqNum: %d\n",buf[2]) ;
	cout.form("EvtLen: %d  Run: %d  Trig: %d  \n",buf[0],buf[1],buf[6]) ;
	cout.form("Status: %4.4x  EvtTime: %s",buf[5],ctime((long *)(buf+3))) ;
	for (int k=0 ; k<buf[7] ; k++) {
		cout.form(" %4d  %2.2d:%4.4d ",k,DetectorID(k),ModuleID(k)) ;
		cout.form("%8.8x  ",buf[8+k*2+1]) ;
		cout.form("%4d %4d",QDC(k),TDC(k)) ;
		cout.form("\n") ;
		}
	cout.form("\n") ;
	}

void	E391aEventReader::Dump() {
	cout.form("E391aEventReader::RecSeqNum: %d\n",buf[2]) ;
	cout.form(" %12d  EvtLength\n",buf[0]) ;
	cout.form(" %12d  RunNumber\n",buf[1]) ;
	cout.form(" %12d  EventSeqNumber\n",buf[2]) ;
	cout.form(" %12d  t1\n",buf[3]) ;
	cout.form(" %12d  t2\n",buf[4]) ;
	cout.form(" %12d  EventStatus\n",buf[5]) ;
	cout.form(" %12d  Trigger\n",buf[6]) ;
	cout.form(" %12d  NumOfSignals\n",buf[7]) ;
	for (int k=0 ; k<buf[7] ; k++) {
		cout.form("   %4d  %2.2d:%4.4d  ",k,DetectorID(k),ModuleID(k)) ;
		cout.form("%8.8x",buf[8+k*2+1]) ;
		cout.form("\n") ;
		}
	cout.form("\n") ;
	}

// EOF
