// File:	E391aRunAction.cc
// File:	16-Apr-2001 G.Macharashvili Juelich

#include "E391aRunAction.hh"

E391aRunAction::E391aRunAction(
		E391aDetectorConstruction* det,
		E391aPrimaryGeneratorAction* gen)
		:
		Det(det),
		Gen(gen) {}

E391aRunAction::~E391aRunAction() {}

void 
E391aRunAction::BeginOfRunAction(const G4Run* Run) {
	Time=(G4Timer*) new G4Timer() ;
	Time->Start() ;
	EventManager = G4EventManager::GetEventManager() ;
	if (RootMsg) RootMsg->SpeedInfo("Run Started ... ") ;
	}

void E391aRunAction::EndOfRunAction(const G4Run* Run) {
	Time->Stop() ;
	G4double te=Time->GetRealElapsed() ;
	G4double ev=Run->GetNumberOfEvent() ;
	G4cout.form("\n(G.M.) E391a Geant4 Run Completed.\n") ;
	G4cout.form("  Events processed: %.0f \n",ev) ;
	G4cout.form(" Elapsed Real Time: %.1f sec.\n",te) ;
	G4cout.form("              Rate: %.1f Evt/sec.\n",ev/te) ;
	G4cout.form("            Status: OK ...\n") ;

	delete Time ;

	}

// EOF
