// File:	HistAnalysis.cc
// Date:	18-May-2001 G.Macharashvili Dubna

#include "HistAnalysis.hh"

HistAnalysis::HistAnalysis() {}

HistAnalysis::~HistAnalysis() {}

void	HistAnalysis::ER(TROOT *R) const {
	cout.form("      HistAnalysis: wait ...") ;
	TH2F* H=(TH2F *)R->FindObject("HEoRes") ;
	TH1F* Se=new TH1F("Se","Energy resolution of CsI Calorimeter",H->GetNbinsX(),H->GetXaxis()->GetXmin(),H->GetXaxis()->GetXmax()) ;
		Se->SetXTitle("#gamma Energy,  GeV") ;
		Se->SetYTitle("#gamma Energy Resolution: s/E  ") ;
	TH1F* hs[H->GetNbinsX()] ;
	for (int i=0 ; i<H->GetNbinsX() ; i++) {
		char s[20] ;
		sprintf(s,"hs[%d]",i) ;
		hs[i]=new TH1F(s,"E(r) - E(g)",H->GetNbinsY(),H->GetYaxis()->GetXmin(),H->GetYaxis()->GetXmax()) ;
		}
	TF1* GF=new TF1("GF","gaus") ;
	TF1* F1=new TF1("F1","[0]/sqrt(x)+[1]",0.05,2.0) ;
	GF->Write() ;
	F1->Write() ;

	for (int ix=1 ; ix<=H->GetNbinsX() ; ix++) {
		hs[ix-1]->Reset() ;
		double s=0 ;
		for (int iy=1 ; iy<=H->GetNbinsY() ; iy++) {
			hs[ix-1]->SetBinContent(iy,H->GetCellContent(ix,iy)) ;
			s+=H->GetCellContent(ix,iy) ;
			}
		if (s<25) continue ; // Small statistics
		hs[ix-1]->Fit("GF","q+") ;
		hs[ix-1]->Fit("GF","Rq+","",GF->GetParameter(1)-2*GF->GetParameter(2),GF->GetParameter(1)+2*GF->GetParameter(2)) ;
		if (GF->GetParameter(2)>0.08) continue ;
		if (GF->GetParError(2)>0.02) continue ;
		Se->SetBinContent(ix,GF->GetParameter(2)) ;
		Se->SetBinError(ix,2*GF->GetParError(2)) ;
		}
	Se->Fit("F1","Rq+","") ;
//+	cout.form("\nResol: a %.3f   b %.3f   ",F1->GetParameter(0),F1->GetParameter(1)) ;
//+	cout.form("Chi2: a %.3f   \n",F1->GetChisquare()) ;
	
//	R->GetListOfGlobals()->Print() ;
	cout.form("\r      HistAnalysis: OK ...    \n") ;
	for (i=0 ; i<H->GetNbinsX() ; i++) hs[i]->Delete() ;
// CCo3 analysis ...
	TH1F* Ho=(TH1F *)R->FindObject("CC3Effo") ;
	TH1F* H1=(TH1F *)R->FindObject("CC3Eff") ;
	H1->Add(H1,Ho,-1,1) ;
	H1->Divide(Ho) ;
// 
	}

// EOF
