

#include "RunMessage.h"


RunMessage::RunMessage() : RunTimer() {

 	Can=new TCanvas("Can","E391a   Status   (G4/ROOT)",0,20,640,200) ;
	Can->Range(0,0,1,1) ;
	Can->SetFillColor(18) ;
	Can->SetBorderSize(2) ;
	Can->Update() ;

	Msg=new TPaveText(0.0, 0.0, 1.0, 0.2) ;
	Msg->AddText("Normal Stop: <Ctrl+C>            ") ;
	Msg->SetFillColor(17) ;
	Msg->SetTextColor(102) ;
	Msg->SetTextAlign(12) ;
	Msg->SetTextSize(0.12) ;
	Msg->Draw() ;

	Msg0=new TPaveText(0.0, 0.2, 1.0, 0.4) ;
	Msg0->SetFillColor(33) ;
	Msg0->SetTextColor(1) ;
	Msg0->SetTextAlign(12) ;
	Msg0->SetTextSize(0.12) ;
	Msg0->Draw() ;

	Msg1=new TPaveText(0.0, 0.4, 1.0, 0.6) ;
	Msg1->AddText("         ") ;
	Msg1->SetFillColor(33) ;
	Msg1->SetTextColor(1) ;
	Msg1->SetTextAlign(12) ;
	Msg1->SetTextSize(0.12) ;
	Msg1->Draw() ;

	Msg2=new TPaveText(0.0, 0.6, 1.0, 0.8) ;
	Msg2->AddText("         ") ;
	Msg2->SetFillColor(33) ;
	Msg2->SetTextColor(1) ;
	Msg2->SetTextAlign(12) ;
	Msg2->SetTextSize(0.12) ;
	Msg2->Draw() ;

	Can->Update() ;

	}

RunMessage::~RunMessage() {}

void	RunMessage::Message(const char *t) {
	Msg1->Clear() ;
	Msg1->AddText(t) ;
	Msg1->Draw() ;
	Can->Update() ;
	}

void	RunMessage::SpeedInfo(const char *t) {
	Msg0->Clear() ;
	Msg0->AddText(t) ;
	Msg0->Draw() ;
	Can->Update() ;
	}

void	RunMessage::SpeedInfo(int NEvent) {
	t2=this->operator()() ;
	dt=t2-t1 ;
	t1=t2 ;
	sprintf(s,          "Evt: %d    ",NEvent) ;
	sprintf(s+strlen(s),"Elapsed: %.2f s.    ",t2) ;
	sprintf(s+strlen(s),"Rate: %.1f Evt/s.",10000./dt) ;
	Msg0->Clear() ;
	Msg0->AddText(s) ;
	Msg0->Draw() ;
	Can->Update() ;
	}

void	RunMessage::Time(const char *h) {
	long	t=time(0) ;
	sprintf(s,"%s  %s",h,ctime(&t)) ;
	Msg2->Clear() ;
	Msg2->AddText(s) ;
	Msg2->Draw() ;
	Can->Update() ;
	}

// EOF
